﻿#Region "FileHeader"
#If False Then
Extends Progress(Of T) with an Minimum-Interval: Progresses, which are reported too frequently will be ignored
#End If '-- Options, Imports
#End Region 'FileHeader
Namespace System

   Public Class IntervalProgress(Of T) : Inherits Progress(Of T)

      Public Interval As TimeSpan = TimeSpan.FromMilliseconds(300)
      Private _LastReport As Date = Date.MinValue
      Public Sub New()
      End Sub
      Public Sub New(action As Action(Of T))
         MyBase.New(action)
      End Sub
      Protected Overrides Sub OnReport(value As T)
         Dim dt = Date.Now
         If dt - _LastReport < Interval Then Return
         _LastReport = dt
         MyBase.OnReport(value)
      End Sub

      Public Sub Report(arg As T)
         OnReport(arg)
      End Sub
      Public Sub FinalReport(arg As T)
         _LastReport = Date.MinValue
         OnReport(arg)
         _LastReport = Date.MinValue
      End Sub

   End Class

End Namespace